package miner.util;

public class ArrayUtil {
	
	public static int[] copy(int[] a)
	{
		int[] a_A = new int[a.length];
		
		for(int i=0; i<a.length; i++)
		{
			a_A[i] = a[i];
		}
		
		return a_A;
	}
	
	public static int[][] copy(int[][] aa)
	{
		int[][] aa_AA = new int[aa.length][];
		
		for(int i=0; i<aa_AA.length; i++)
		{
			aa_AA[i] = new int[aa[i].length];
			
			for(int j=0; j<aa_AA[i].length; j++)
			{
				aa_AA[i][j] = aa[i][j];
			}
		}
		
		return aa_AA;
	}
	
	public static double sum(double[] a)
	{
		double sum = 0;
		
		for(int i=0; i<a.length; i++)
		{
			sum = sum + a[i];
		}
		return sum;
	}
	
	public static int sum(int[] a)
	{
		int sum = 0;
		
		for(int i=0; i<a.length; i++)
		{
			sum = sum + a[i];
		}
		return sum;
	}
	
	public static int numArrayElements(int[][] aa)
	{
		int retV = 0;
		
		for(int i=0; i<aa.length; i++)
		{
			retV = retV + aa[i].length;
		}
		
		return retV;
	}
	
	public static int indexOfMin(double[] a)
	{
		int minIndex = 0;
		double minValue = Double.NEGATIVE_INFINITY;
		
		for(int i=0; i<a.length; i++)
		{
			if(minValue > a[i])
			{
				minValue = a[i];
				minIndex = i;
			}
		}
		return minIndex;
	}
	
	public static int[] sort(double[] a)
	{
		int[] permut = new int[a.length];
		
		for(int i=0; i< permut.length; i++)
		{
			permut[i] = i+1;
		}
		
		quicksort(0, a.length-1, a, permut);
		
		return permut;
	}
	
	public static void quicksort(int l, int r, double[] a, int[] p)
	{
		if(l < r)
		{
			int div = divide(l, r, a, p);
			quicksort(l, div-1, a, p);
			quicksort(div+1, r, a, p);
		}
	}
	
	public static int[] sort(int[] a)
	{
		int[] permut = new int[a.length];
		
		for(int i=0; i< permut.length; i++)
		{
			permut[i] = i+1;
		}
		
		quicksort(0, a.length-1, a, permut);
		
		return permut;
	}
	
	public static void quicksort(int l, int r, int[] a, int[] p)
	{
		if(l < r)
		{
			int div = divide(l, r, a, p);
			quicksort(l, div-1, a, p);
			quicksort(div+1, r, a, p);
		}
	}
	
	public static int[] revers(int[] a)
	{
		int[] ret_A = new int[a.length];
		
		for(int i=0; i<ret_A.length; i++)
		{
			ret_A[i] = a[a.length-1-i];
		}
		
		return ret_A;
	}
	
	private static int divide(int l, int r, double[] a, int[] p)
	{
		int i = l;
		int j = r-1;
		
		double pivot = a[r];
		
		double help;
		int helpP;
		
		do
		{
			while(a[i] <= pivot && i < r)
			{
				i++;
			}
			while(a[j] >= pivot && l < j)
			{
				j--;
			}
			
			if(i < j)
			{
				help = a[i];
				a[i] = a[j];
				a[j] = help;
				
				helpP = p[i];
				p[i] = p[j];
				p[j] = helpP;
			}
			
			if(a[i] > pivot)
			{
				help = a[i];
				a[i] = a[r];
				a[r] = help;
				
				helpP = p[i];
				p[i] = p[r];
				p[r] = helpP;
			}
		}while(i < j);

		return i;
	}
	
	private static int divide(int l, int r, int[] a, int[] p)
	{
		int i = l;
		int j = r-1;
		
		int pivot = a[r];
		
		int help;
		int helpP;
		
		do
		{
			while(a[i] <= pivot && i < r)
			{
				i++;
			}
			while(a[j] >= pivot && l < j)
			{
				j--;
			}
			
			if(i < j)
			{
				help = a[i];
				a[i] = a[j];
				a[j] = help;
				
				helpP = p[i];
				p[i] = p[j];
				p[j] = helpP;
			}
			
			if(a[i] > pivot)
			{
				help = a[i];
				a[i] = a[r];
				a[r] = help;
				
				helpP = p[i];
				p[i] = p[r];
				p[r] = helpP;
			}
		}while(i < j);

		return i;
	}

}
