package miner.util;

public class BitVector {
	
	public int[] list;
	
	public BitVector(BitVector bv)
	{
		this.list = new int[bv.list.length];
		
		for(int i=0; i<list.length; i++)
		{
			list[i] = bv.list[i];
		}
	}
	
	public BitVector(int length)
	{
		list = new int[(int)Math.ceil(length/(double)31)];
	}
	
	public void add(int i)
	{
		int index 	= (i-1)/31;			
		list[index] 	= list[index] ^ (int)Math.pow(2, ((i-1) % 31));
	}
	
	public void remove(int i)
	{
		int index 	= (i-1)/31;			
		list[index] 	= list[index] & (int)(- Math.pow(2, ((i-1) % 31)) - 1);
	}
	
	public int getBitAt(int index)
	{
		int i 	= (index-1)/31;
		
		//TODO
		return 0;
	}
	
	public BitVector AND(BitVector bv)
	{	
		BitVector retV = new BitVector(bv.list.length * 31);
		
		try {
		for(int i=0; i<bv.list.length; i++)
		{
			retV.list[i] = this.list[i] & bv.list[i];		
		}
		} catch(ArrayIndexOutOfBoundsException e)
		{
			System.out.println(this.list.length + " " + bv.list.length);
		}

		return retV;
	}
	
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		
		for(int i=0; i<list.length; i++)
		{
			sb.append(Integer.toBinaryString(list[i]) + "\n");
		}
		
		return sb.toString();
	}

}
