package miner.util;

import util.FormatUtil;

public class OTFWrapper implements Comparable<OTFWrapper>{
	
	public ObjectTuple ot;
	public double frequency;
	
	public OTFWrapper(ObjectTuple ot, double frequency)
	{
		this.ot 		= ot;
		this.frequency 	= frequency;
	}

	@Override
	public int compareTo(OTFWrapper arg0) {
		
		if(frequency < arg0.frequency) return 1;
		if(frequency > arg0.frequency) return -1;
		
		return 0;
	}
	
	public String toString()
	{
		return ot.toString() + "(" + FormatUtil.cutDecimal(this.frequency,3) + ")";
	}

}
