package miner.util;

import java.util.ArrayList;

public class ObjectNode {
	
	private ArrayList<ObjectNode> 	children_L 	= new ArrayList<>();
	public TransactionList 			tl 			= null;
	public int 						value;
	
	//#########################################################################
	// Constructor
	//#########################################################################
	
	public ObjectNode(int value, TransactionList tl)
	{
		this.value 	= value;
		this.tl		= tl;
	}
	
	//#########################################################################
	// Business Methods
	//#########################################################################
	
	public void addNode(ObjectNode node)
	{
		children_L.add(node);
	}
	
	public ObjectNode getNode(int index)
	{
		return children_L.get(index);
	}
	
	public int numChildren()
	{
		return children_L.size();
	}
	
	public int getValue()
	{
		return this.value;
	}
	
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		if(children_L.size() > 0)
		{
			sb.append(value + "-[");
			for(ObjectNode ifn: children_L)
			{
				sb.append(ifn.toString());
			}
			sb.append("]");
		}
		else sb.append(value+",");
		
		return sb.toString();
	}
	@Override
	public boolean equals(Object o1)
	{
		return this.value == ((ObjectNode)o1).value;
	}
	
	@Override
	public int hashCode()
	{
		return value;
	}
	

}
