package miner.util;

import java.util.ArrayList;

public class TransactionBitR {
	
	public int[] list;
	
	private int hashValue = 0;
	
	//#########################################################################
	// Constructor
	//#########################################################################
	
	public TransactionBitR(int[] ranking)
	{
		list = rankingToBits(ranking);
	}
	
	public TransactionBitR(int lSize)
	{
		list = new int[lSize];
	}
	
	//#########################################################################
	// static Methods
	//#########################################################################
	
	public static int[] rankingToBits(int[] r)
	{
		
		int[] ret = new int[(int)Math.ceil((r.length*(r.length-1))/(double)31)];
			
	
		
		int k = 0;
		int c = 0;
		for(int i=0; i<r.length-1; i++)
		{
			for(int j=i+1; j<r.length; j++)
			{
				if(r[i] > 0 && r[j] > 0)
				{
					if(r[i] < r[j])
					{
						ret[k] = ret[k] | (int)Math.pow(2, c);
						c = c + 2;
					}
					else
					{
						c++;
						ret[k] = ret[k] | (int)Math.pow(2, c);
						c++;
					}
				}
				else
				{
					c = c + 2;
				}

				if(c > 30)
				{
					k++;
					c = 0;
				}
			}
		}
		
		return ret;
	}
	
	//#########################################################################
	// business Methods
	//#########################################################################
	
	// AND Operation -> intersection of two Transactcionlists.
	public TransactionBitR AND(TransactionBitR tl)
	{	
		TransactionBitR retV = new TransactionBitR(tl.list.length);
		
		for(int i=0; i<tl.list.length; i++)
		{
			retV.list[i] = this.list[i] & tl.list[i];		
		}

		return retV;
	}
	
	public static int[] AND(int[] l1, int[] l2)
	{	
		int[] ret_A = new int[l1.length];
		
		for(int i=0; i<l1.length; i++)
		{
			ret_A[i] = l1[i] & l2[i];		
		}

		return ret_A;
	}
	
	public ArrayList<Integer> getTransactions()
	{
		ArrayList<Integer> ret_L = new ArrayList<>();
		
		int trans;
		
		for(int i=0; i<list.length; i++)
		{
			trans = 31*i;
			
			int b = list[i];
			int c = 0;
			
			while(b != 0)
			{
				c = b & (0 - b);
				
				ret_L.add(trans + Integer.numberOfTrailingZeros(c) + 1);
				
				b = b ^ c;
			}
			
		}		
		return ret_L;
	}
	
	public void add(int i)
	{
		int index 	= (i-1)/31;			
		list[index] 	= list[index] ^ (int)Math.pow(2, ((i-1) % 31));
	}
	
	public boolean contains(TransactionBitR tl)
	{
		return tl.equals(this.AND(tl));
	}
	
	public int count()
	{
		int retV = 0;
		
		for(int i: this.list)
		{
			retV = retV + Integer.bitCount(i);
		}
		
		return retV;
	}
	
	public void setHashValue(int hashValue)
	{
		this.hashValue = hashValue;
	}
	
	@Override
	public boolean equals(Object obj)
	{
		TransactionBitR tl = (TransactionBitR)obj;
		
		if(tl.list.length != this.list.length) return false;
		
		for(int i=0; i<this.list.length; i++)
		{
			if(this.list[i] != tl.list[i]) return false;
		}
		
		return true;
	}
	
//	@Override
//	public int hashCode()
//	{
//		return hashValue;
//	}
	
	@Override
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		for(int i=0; i<this.list.length; i++)
		{
			sb.append(Integer.toBinaryString(this.list[i]) + " | ");
		}
//		sb.append(" h:" + hashCode());
		
		return sb.toString();
	}

}
