package util;

import java.util.ArrayList;

import correlation.KendallTauA;
import miner.util.ObjectTuple;

public class Util {
	
	public static double[][] patternClusterHeatMap(ArrayList<int[]> rankings, int[][] cluster, ArrayList<ObjectTuple> pattern, String type)
	{
		int[][] rankings_A = new int[rankings.size()][rankings.get(0).length];
		rankings.toArray(rankings_A);
		
		return patternClusterHeatMap(rankings_A,cluster,pattern, type);
	}
	
	public static double[][] patternClusterHeatMap(ArrayList<ObjectTuple> pattern1, int[][] cluster, ArrayList<ObjectTuple> pattern2, int rSize, String type)
	{
		int[][] rankings_A = new int[pattern1.size()][rSize];
		
		for(int i=0; i<pattern1.size(); i++)
		{
			rankings_A[i] = pattern1.get(i).getRanking(rSize);
		}
		
		return patternClusterHeatMap(rankings_A, cluster, pattern2, type);
	}
	
	public static double[][] patternClusterHeatMap(int[][] rankings, int[][] cluster, ArrayList<ObjectTuple> pattern, String type)
	{
		double[][] ret_AA = new double[cluster.length][pattern.size()];
		
		for(int c=0; c<cluster.length; c++)
		{
			for(int p=0; p<pattern.size(); p++)
			{
				for(int in: cluster[c])
				{
System.out.println(c + " " + p);
					if(type.equals("AVG"))
						ret_AA[c][p] = ret_AA[c][p] + KendallTauA.disAvgExtension(rankings[in], pattern.get(p).getRanking(rankings[in].length));
					else if(type.equals("MIN"))
						ret_AA[c][p] = ret_AA[c][p] + KendallTauA.disMinExtension(rankings[in], pattern.get(p).getRanking(rankings[in].length));
				}
				
				ret_AA[c][p] = ret_AA[c][p]/cluster[c].length;
			}
		}
		
		return ret_AA;
	}

}
